/*------------------------------------------------------------------------------------
   Name: xMA-Histo.mq4
   Copyright ?2010, Xaphod, http://forexwhiz.appspot.com
   
   Description: MA-Cross Histogram

   Change log: 
       2010-06-28. Xaphod, v1.00 
          - First Release 
-------------------------------------------------------------------------------------*/
// Indicator properties
#property copyright "Copyright ? 2010, Xaphod"
#property link      "http://forexwhiz.appspot.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Yellow
#property indicator_color2  Yellow
#property indicator_color3  Green
#property indicator_color4  Crimson
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_maximum 1
#property indicator_minimum 0

// Constant definitions
#define INDICATOR_NAME "MA - crosses histo"
#define INDICATOR_VERSION "v1.00"
#define BAR_HEIGHT 1.00

// Indicator parameters
extern int       MA1.Period=2;
extern int       MA1.Method=MODE_SMA;
extern int       MA1.Price=PRICE_CLOSE;
extern int       MA2.Period=7;
extern int       MA2.Method=MODE_SMA;
extern int       MA2.Price=PRICE_CLOSE;

// Global module varables
double dBuffer0[];
double dBuffer1[];
double dBuffer2[];
double dBuffer3[];

//-----------------------------------------------------------------------------
// function: init()
// Description: Custom indicator initialization function.
//-----------------------------------------------------------------------------
int init() {
   IndicatorShortName(INDICATOR_NAME +"("+INDICATOR_VERSION + ")");
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,dBuffer0);
   SetIndexLabel(0,NULL);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dBuffer1);
   SetIndexLabel(1,NULL);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,dBuffer2);
   SetIndexLabel(2,"Cross-Up");
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,dBuffer3);
   SetIndexLabel(3,"Cross-Down");
   IndicatorDigits(2);

  return(0);
}

//-----------------------------------------------------------------------------
// function: deinit()
// Description: Custom indicator deinitialization function.
//-----------------------------------------------------------------------------
int deinit() {
   return (0);
}


///-----------------------------------------------------------------------------
// function: start()
// Description: Custom indicator iteration function.
//-----------------------------------------------------------------------------
int start() {
  int iNewBars;
  int iCountedBars; 
  int i;
  
  
  // Get unprocessed ticks
  iCountedBars=IndicatorCounted();
  if(iCountedBars < 0) return (-1); 
  if(iCountedBars>0) iCountedBars--;
  iNewBars=Bars-iCountedBars;
  
  for(i=iNewBars; i>=0; i--) {
      dBuffer0[i] = iMA(NULL,0,MA1.Period,0,MA1.Method,MA1.Price,i);
      dBuffer1[i] = iMA(NULL,0,MA2.Period,0,MA2.Method,MA2.Price,i);
      dBuffer2[i] = EMPTY_VALUE;
      dBuffer3[i] = EMPTY_VALUE;
            
     if (dBuffer0[i] >= dBuffer1[i]) dBuffer2[i] = BAR_HEIGHT;
     if (dBuffer0[i] < dBuffer1[i]) dBuffer3[i] = BAR_HEIGHT;
   }
  
  return(0);
}
//+------------------------------------------------------------------+